diff -uNrp 2.6.12-bfin/arch/bfinnommu/mach-common/ints-priority-sc.c 2.6.12-bfin-ipipe/arch/bfinnommu/mach-common/ints-priority-sc.c
--- 2.6.12-bfin/arch/bfinnommu/mach-common/ints-priority-sc.c	2005-09-07 10:37:41.000000000 +0200
+++ 2.6.12-bfin-ipipe/arch/bfinnommu/mach-common/ints-priority-sc.c	2005-10-18 10:24:06.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * $Id: ints-priority-sc.c,v 1.7 2005/09/07 08:37:41 bernds Exp $ 
+ * $Id: ints-priority-sc.c,v 1.6 2005/10/18 08:24:06 rpm Exp $ 
  *
  *arch/bfinnommu/mach-common/ints-priority.c
  *
@@ -108,33 +108,50 @@ static void __init search_IAR(void)	
 
 static void bf533_core_mask_irq(unsigned int irq)
 {
-	local_irq_disable();
+	local_irq_disable_hw();
 	irq_flags &= ~(1<<irq);
-	local_irq_enable();
+	local_irq_enable_hw();
 }
 
 static void bf533_core_unmask_irq(unsigned int irq)
 {
 	/* enable the interrupt */
-	local_irq_disable();
+	local_irq_disable_hw();
 	irq_flags |= 1<<irq;
-	local_irq_enable();
+	local_irq_enable_hw();
 	return;
 }
 
 static void bf533_internal_mask_irq(unsigned int irq)
 {
-  //dummy function
+#ifdef CONFIG_IPIPE
+	/* With Adeos on board, we do need to mask the interrupt as
+	 * part of our fast ack cycle in __ipipe_handle_irq(), so that
+	 * no interrupt storm can happen with level-triggered IRQs.
+	 * Remember that the actual IRQ handler execution may be
+	 * postponed until we exit from some undergoing Linux critical
+	 * section, so we must find a way to keep the interrupt line
+	 * quiet until then, at the latest. High priority domains
+	 * above Linux may handle this differently and earlier using
+	 * their own acknowledge routine passed to
+	 * ipipe_virtualize_irq(). */
+	unsigned long irq_mask;
+	local_irq_disable_hw();
+	irq_mask = (1<<(irq - (IRQ_CORETMR+1)));
+   	*pSIC_IMASK &= ~irq_mask;
+	__builtin_bfin_ssync();
+	local_irq_enable_hw();
+#endif /* CONFIG_IPIPE */
 }
 
 static void bf533_internal_unmask_irq(unsigned int irq)
 {
 	unsigned long irq_mask;
-	local_irq_disable();
+	local_irq_disable_hw();
 	irq_mask = (1<<(irq - (IRQ_CORETMR+1)));
    	*pSIC_IMASK |= irq_mask;
 	__builtin_bfin_ssync();
-	local_irq_enable();
+	local_irq_enable_hw();
 }
 
 static struct irqchip bf533_core_irqchip = {
@@ -163,19 +180,19 @@ static void bf537_generic_error_mask_irq
 
 	if(!error_int_mask) 
 		{
-			local_irq_disable();
+			local_irq_disable_hw();
 		   	*pSIC_IMASK |= (1<<(IRQ_GENERIC_ERROR - (IRQ_CORETMR+1)));
 			__builtin_bfin_ssync();
-			local_irq_enable();		
+			local_irq_enable_hw();		
 		}
 }
 
 static void bf537_generic_error_unmask_irq(unsigned int irq)
 {
-	local_irq_disable();
+	local_irq_disable_hw();
 	*pSIC_IMASK |= (1<<(IRQ_GENERIC_ERROR - (IRQ_CORETMR+1)));
 	__builtin_bfin_ssync();
-	local_irq_enable();
+	local_irq_enable_hw();
 
 	error_int_mask |= (1L << (irq - IRQ_PPI_ERROR));
 }
@@ -232,6 +249,10 @@ static void bf533_gpio_ack_irq(unsigned 
 	int gpionr = irq - IRQ_PF0;
 	int mask = (1L << gpionr);
 	*pFIO_FLAG_C = mask;
+#ifdef CONFIG_IPIPE
+	__builtin_bfin_ssync();
+	*pFIO_MASKB_C = mask;
+#endif /* CONFIG_IPIPE */
 //	if (gpio_edge_triggered & mask) {
 //		/* ack */
 //	} else {
@@ -463,3 +484,55 @@ void do_irq(int vec, struct pt_regs *fp)
 
 	asm_do_IRQ(vec, fp);
 }
+
+#ifdef CONFIG_IPIPE
+
+/* Hw interrupts are unmasked for higher priority levels on entry. */
+
+asmlinkage void __ipipe_grab_irq(int vec, struct pt_regs *regs)
+{
+	struct ivgx *ivg = ivg7_13[vec-IVG7].ifirst;
+	struct ivgx *ivg_stop = ivg7_13[vec-IVG7].istop;
+	unsigned long sic_status, flags;
+
+	__builtin_bfin_ssync();
+ 	sic_status = *pSIC_IMASK & *pSIC_ISR;
+
+	for(;; ivg++) {
+		if (ivg >= ivg_stop)  {
+			num_spurious++;
+			return;
+		}
+		else if (sic_status & ivg->isrflag)
+			break;
+	}
+
+	vec = ivg->irqno;
+	local_irq_save_hw(flags);
+	__ipipe_handle_irq(vec, regs);
+	local_irq_restore_hw(flags);
+}
+
+/* Hw interrupts are unmasked for higher priority levels on entry. */
+
+asmlinkage int __ipipe_grab_timer(unsigned irq, struct pt_regs *regs)
+{
+	unsigned long flags;
+	ipipe_declare_cpuid;
+
+	local_irq_save_hw(flags);
+
+	ipipe_load_cpuid();
+
+	__ipipe_tick_regs[cpuid].ipend = regs->ipend; /* for update_process_times() */
+
+	__ipipe_handle_irq(irq, regs);
+
+	local_irq_restore_hw(flags);
+
+	return (ipipe_percpu_domain[cpuid] == ipipe_root_domain &&
+		!test_bit(IPIPE_STALL_FLAG,
+			  &ipipe_root_domain->cpudata[cpuid].status));
+}
+
+#endif /* CONFIG_IPIPE */
diff -uNrp 2.6.12-bfin/include/asm-bfinnommu/bitops.h 2.6.12-bfin-ipipe/include/asm-bfinnommu/bitops.h
--- 2.6.12-bfin/include/asm-bfinnommu/bitops.h	2005-08-12 04:43:39.000000000 +0200
+++ 2.6.12-bfin-ipipe/include/asm-bfinnommu/bitops.h	2005-10-16 18:40:06.000000000 +0200
@@ -87,9 +87,9 @@ static __inline__ void set_bit(int nr, v
 
 	a += nr >> 5;
 	mask = 1 << (nr & 0x1f);
-	local_irq_save(flags);
+	local_irq_save_hw(flags);
 	*a |= mask;
-	local_irq_restore(flags);
+	local_irq_restore_hw(flags);
 }
 
 static __inline__ void __set_bit(int nr, volatile unsigned long * addr)
@@ -115,9 +115,9 @@ static __inline__ void clear_bit(int nr,
 	unsigned long flags;
 	a += nr >> 5;
 	mask = 1 << (nr & 0x1f);
-	local_irq_save(flags);
+	local_irq_save_hw(flags);
 	*a &= ~mask;
-	local_irq_restore(flags);
+	local_irq_restore_hw(flags);
 }
 
 static __inline__ void __clear_bit(int nr, volatile unsigned long * addr)
@@ -137,9 +137,9 @@ static __inline__ void change_bit(int nr
 
 	ADDR += nr >> 5;
 	mask = 1 << (nr & 31);
-	local_irq_save(flags);
+	local_irq_save_hw(flags);
 	*ADDR ^= mask;
-	local_irq_restore(flags);
+	local_irq_restore_hw(flags);
 }
 
 static __inline__ void __change_bit(int nr, volatile unsigned long * addr)
@@ -160,10 +160,10 @@ static __inline__ int test_and_set_bit(i
 
 	a += nr >> 5;
 	mask = 1 << (nr & 0x1f);
-	local_irq_save(flags); 
+	local_irq_save_hw(flags); 
 	retval = (mask & *a) != 0;
 	*a |= mask;
-	local_irq_restore(flags); 
+	local_irq_restore_hw(flags); 
 
 	return retval;
 }
@@ -188,10 +188,10 @@ static __inline__ int test_and_clear_bit
 
 	a += nr >> 5;
 	mask = 1 << (nr & 0x1f);
-	local_irq_save(flags);
+	local_irq_save_hw(flags);
 	retval = (mask & *a) != 0;
 	*a &= ~mask;
-	local_irq_restore(flags);
+	local_irq_restore_hw(flags);
 
 	return retval;
 }
@@ -216,10 +216,10 @@ static __inline__ int test_and_change_bi
 
 	a += nr >> 5;
 	mask = 1 << (nr & 0x1f);
-	local_irq_save(flags);
+	local_irq_save_hw(flags);
 	retval = (mask & *a) != 0;
 	*a ^= mask;
-	local_irq_restore(flags);
+	local_irq_restore_hw(flags);
 	return retval;
 }
 
diff -uNrp 2.6.12-bfin/include/asm-bfinnommu/ipipe.h 2.6.12-bfin-ipipe/include/asm-bfinnommu/ipipe.h
--- 2.6.12-bfin/include/asm-bfinnommu/ipipe.h	1970-01-01 01:00:00.000000000 +0100
+++ 2.6.12-bfin-ipipe/include/asm-bfinnommu/ipipe.h	2005-10-20 17:25:18.000000000 +0200
@@ -0,0 +1,147 @@
+/*   -*- linux-c -*-
+ *   include/asm-bfinnommu/ipipe.h
+ *
+ *   Copyright (C) 2002-2005 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#ifndef __BFINNOMMU_IPIPE_H
+#define __NBINNOMMU_IPIPE_H
+
+#include <linux/config.h>
+
+#ifdef CONFIG_IPIPE
+
+#include <linux/cpumask.h>
+#include <linux/list.h>
+#include <linux/threads.h>
+#include <asm/ptrace.h>
+#include <asm/mach/irq.h>
+#include <asm/bitops.h>
+#include <asm/traps.h>
+
+#define IPIPE_ARCH_STRING     "1.0-00"
+#define IPIPE_MAJOR_NUMBER    1
+#define IPIPE_MINOR_NUMBER    0
+#define IPIPE_PATCH_NUMBER    0
+
+#define IPIPE_NR_XIRQS		NR_IRQS
+#define IPIPE_IRQ_ISHIFT	5	/* 2^5 for 32bits arch. */
+
+#ifdef CONFIG_SMP
+#error "I-pipe/bfinnommu: SMP not implemented"
+#else /* !CONFIG_SMP */
+#define ipipe_processor_id()	0
+#endif	/* CONFIG_SMP */
+
+#define prepare_arch_switch(rq, next)		\
+do { \
+	__ipipe_dispatch_event(IPIPE_EVENT_SCHEDULE,next);	\
+	local_irq_disable_hw();					\
+} while(0)
+
+#define task_running(rq, p)		((rq)->curr == (p))
+#define finish_arch_switch(rq, next)	spin_unlock_irq(&(rq)->lock)
+
+#define task_hijacked(p)	\
+  ({ int x = ipipe_current_domain != ipipe_root_domain; \
+     __clear_bit(IPIPE_SYNC_FLAG,&ipipe_root_domain->cpudata[task_cpu(p)].status); \
+     local_irq_enable_hw(); x; })
+
+ /* Blackfin traps -- i.e. exception vector numbers */
+#define IPIPE_NR_FAULTS		64 /* We leave a gap after VEC_ILL_RES. */
+/* Pseudo-vectors used for kernel events */
+#define IPIPE_FIRST_EVENT	IPIPE_NR_FAULTS
+#define IPIPE_EVENT_SYSCALL	(IPIPE_FIRST_EVENT)
+#define IPIPE_EVENT_SCHEDULE	(IPIPE_FIRST_EVENT + 1)
+#define IPIPE_EVENT_SIGWAKE	(IPIPE_FIRST_EVENT + 2)
+#define IPIPE_EVENT_SETSCHED	(IPIPE_FIRST_EVENT + 3)
+#define IPIPE_EVENT_EXIT	(IPIPE_FIRST_EVENT + 4)
+#define IPIPE_LAST_EVENT	IPIPE_EVENT_EXIT
+#define IPIPE_NR_EVENTS		(IPIPE_LAST_EVENT + 1)
+
+struct ipipe_domain;
+
+struct ipipe_sysinfo {
+
+	int ncpus;		/* Number of CPUs on board */
+	u64 cpufreq;		/* CPU frequency (in Hz) */
+
+	/* Arch-dependent block */
+
+	struct {
+		unsigned tmirq;	/* Timer tick IRQ */
+		u64 tmfreq;	/* Timer frequency */
+	} archdep;
+};
+
+#define ipipe_read_tsc(t)					\
+	({							\
+	unsigned long __cy2;					\
+	__asm__ __volatile__ (	"CLI R0\n"			\
+				"1: %0 = CYCLES\n"		\
+				"%1 = CYCLES2\n"		\
+				"%2 = CYCLES\n"			\
+				"CC = %2 < %0 (IU)\n"		\
+				"if CC jump 1b\n"		\
+				"STI R0\n"			\
+				:"=r" (((unsigned long *)&t)[0]),	\
+				"=r" (((unsigned long *)&t)[1]),	\
+				"=r" (__cy2)				\
+				: /*no input*/ : "CC", "R0");		\
+	t;								\
+	})
+#define ipipe_cpu_freq()	__ipipe_core_clock
+#define ipipe_tsc2ns(t)		(((unsigned long)t) * __ipipe_freq_scale)
+
+/* Private interface -- Internal use only */
+
+#define __ipipe_check_platform()	do { } while(0)
+
+#define __ipipe_init_platform()		do { } while(0)
+
+void __ipipe_enable_pipeline(void);
+
+void __ipipe_sync_stage(unsigned long syncmask);
+
+int __ipipe_ack_irq(unsigned irq);
+
+void __ipipe_do_IRQ(unsigned irq,
+		    struct pt_regs *regs);
+
+void __ipipe_do_timer(unsigned irq,
+		      struct pt_regs *regs);
+
+void __ipipe_handle_irq(unsigned irq,
+			struct pt_regs *regs);
+
+extern struct pt_regs __ipipe_tick_regs[];
+
+extern unsigned long __ipipe_core_clock;
+
+extern unsigned long __ipipe_freq_scale;
+
+#define __ipipe_tick_irq  IRQ_CORETMR
+
+#else /* !CONFIG_IPIPE */
+
+#define task_hijacked(p)	0
+#define ipipe_trap_notify(t,r)  0
+
+#endif /* CONFIG_IPIPE */
+
+#endif	/* !__BFINNOMMU_IPIPE_H */
diff -uNrp 2.6.12-bfin/include/asm-bfinnommu/pgalloc.h 2.6.12-bfin-ipipe/include/asm-bfinnommu/pgalloc.h
--- 2.6.12-bfin/include/asm-bfinnommu/pgalloc.h	2005-01-17 13:28:24.000000000 +0100
+++ 2.6.12-bfin-ipipe/include/asm-bfinnommu/pgalloc.h	2005-10-16 18:25:54.000000000 +0200
@@ -5,4 +5,9 @@
 
 #define check_pgt_cache()	do { } while (0)
 
+static inline void set_pgdir(unsigned long address, pgd_t entry)
+{
+    /* nop */
+}
+
 #endif /* _BFINNOMMU_PGALLOC_H */
diff -uNrp 2.6.12-bfin/include/asm-bfinnommu/system.h 2.6.12-bfin-ipipe/include/asm-bfinnommu/system.h
--- 2.6.12-bfin/include/asm-bfinnommu/system.h	2005-06-13 10:44:27.000000000 +0200
+++ 2.6.12-bfin-ipipe/include/asm-bfinnommu/system.h	2005-10-17 19:57:11.000000000 +0200
@@ -46,6 +46,66 @@ asmlinkage void resume(void);
 
 extern volatile unsigned long irq_flags;
 			
+#ifdef CONFIG_IPIPE
+
+void __ipipe_stall_root(void);
+
+void __ipipe_unstall_root(void);
+
+unsigned long __ipipe_test_root(void);
+
+unsigned long __ipipe_test_and_stall_root(void);
+
+void fastcall __ipipe_restore_root(unsigned long flags);
+
+#define local_save_flags(x)				\
+do {							\
+	(x) = __ipipe_test_root();			\
+} while(0)
+#define local_irq_save(x)			\
+do {						\
+	(x) = __ipipe_test_and_stall_root();	\
+} while(0)
+#define local_irq_restore(x)	__ipipe_restore_root(x)
+#define local_irq_disable()	__ipipe_stall_root()
+#define local_irq_enable()	__ipipe_unstall_root()
+#define irqs_disabled()		__ipipe_test_root()
+
+#define local_irq_enable_hw() 		\
+do {					\
+	__asm__ __volatile__ (		\
+		"sti %0;"		\
+		::"d"(irq_flags));	\
+} while(0)
+
+#define local_irq_disable_hw() 		\
+do {					\
+	int _tmp_dummy;			\
+	__asm__ __volatile__ (		\
+		"cli %0;"		\
+		:"=d" (_tmp_dummy):);	\
+} while(0)
+
+#define local_irq_save_hw(x) 		\
+do {					\
+	__asm__ __volatile__ (          \
+		"cli %0;"		\
+		:"=d"(x):);         	\
+} while(0)
+
+#define local_save_flags_hw(x) asm volatile ("cli %0;sti %0;":"=d"(x):)
+
+#define local_irq_restore_hw(x) asm volatile ("sti %0;" ::"d"(x))
+
+#define	irqs_disabled_hw()		\
+({					\
+	unsigned long flags;		\
+	local_save_flags_hw(flags);	\
+	(flags == 0x1f);	\
+})
+
+#else /* !CONFIG_IPIPE */
+
 #define local_irq_enable() {		\
 	__asm__ __volatile__ (		\
 		"sti %0;"		\
@@ -82,6 +142,13 @@ if (irq_flags == 0) printk("Whoops\n");	
 	(flags  == 0x1f);	\
 })
 
+#define local_irq_save_hw(flags)	local_irq_save(flags)
+#define local_irq_restore_hw(flags)	local_irq_restore(flags)
+#define local_irq_enable_hw()		local_irq_enable()
+#define local_irq_disable_hw(flags)	local_irq_disable()
+
+#endif /* CONFIG_IPIPE */
+
 /*
  * Force strict CPU ordering.
  */
diff -uNrp 2.6.12-bfin/include/linux/hardirq.h 2.6.12-bfin-ipipe/include/linux/hardirq.h
--- 2.6.12-bfin/include/linux/hardirq.h	2005-08-15 11:13:56.000000000 +0200
+++ 2.6.12-bfin-ipipe/include/linux/hardirq.h	2005-10-16 17:59:04.000000000 +0200
@@ -86,8 +86,21 @@ extern void synchronize_irq(unsigned int
 # define synchronize_irq(irq)	barrier()
 #endif
 
+#ifdef CONFIG_IPIPE
+#define nmi_enter() \
+do { \
+    if (ipipe_current_domain == ipipe_root_domain) \
+	irq_enter(); \
+} while(0)
+#define nmi_exit() \
+do { \
+    if (ipipe_current_domain == ipipe_root_domain) \
+	sub_preempt_count(HARDIRQ_OFFSET); \
+} while(0)
+#else /* !CONFIG_IPIPE */
 #define nmi_enter()		irq_enter()
 #define nmi_exit()		sub_preempt_count(HARDIRQ_OFFSET)
+#endif /* CONFIG_IPIPE */
 
 #ifndef CONFIG_VIRT_CPU_ACCOUNTING
 static inline void account_user_vtime(struct task_struct *tsk)
